10 REMark --------- Printer driver for the patched Quill ----------
20 REMark to provide printing of user defined characters
30 REMark the font file is only needed in the case of bit image characters
40 REMark insert your own font file name in line 100
45 REMark set up your printer data in the following lines
47 :
50 ESC$=CHR$(27) : NLQ$=ESC$&'x'&CHR$(1) : BOLD$=ESC$&'E' : PICA$=ESC$&'P' : ELITE$=ESC$&'M' : BITIMAGE$=ESC$&'*'&CHR$(5)
60 LFPITCH$=ESC$&'3'&CHR$(48) : RST$=ESC$ & '@' : UNI$=ESC$ & 'U' & CHR$(1)
70 PREAMBLE$=RST$ & NLQ$ & UNI$ & LFPITCH$ & ELITE$ : REMark Elite is the smaller one
80 POSTAMBLE$=RST$&CHR$(10)&CHR$(10)
90 MODE 4
100 FILNAM$='FLP1_GREEK_FONT'
110 FONT2=ALCHP(2048) : LBYTES FILNAM$,FONT2
120 SPOOL
130 CLCHP
140 :
3000 DEFine PROCedure SPOOL
3010 LOCal N,M,I,A$,B$,CHARS$(255,20)
3020 FOR N=0 TO 255 : CHARS$(N)=CHR$(N)
3030 RESTORE 3580 : PRINT 'Reading Character replace table'
3040 REPeat REPLACE1
3050    READ N : IF N<0 THEN EXIT REPLACE1
3060    CHARS$(N)=''
3070    REPeat REPLACE2
3080       READ M : IF M>255 THEN EXIT REPLACE2
3090       CHARS$(N)=CHARS$(N)&CHR$(M)
3100       END REPeat REPLACE2
3110    END REPeat REPLACE1
3120 PRINT 'Generating dot image characters'
3130 REPeat DOTIMAGE
3140    READ N : IF N>255 THEN EXIT DOTIMAGE
3150    CHARS$(N)=BITIMAGE$&CHR$(6)&CHR$(0)&PATTERN$(N,6)
3155 REMark **** CHR$(27);'*'CHR$(5) starts 576 Dots bitimage graphic mode. It is aligned for ELITE NLQ on Seikosha SP - 800 ****
3160    END REPeat DOTIMAGE
3170 INPUT 'Text file ?',A$ : OPEN_IN #3,A$
3175 PRINT 'Emulating Subscript and Superscript ? (Y/N)' : A$=INKEY$(200) : EMULATE=1 : IF A$='N' OR A$='n' THEN EMULATE=0
3180 OPEN #4,SER1HR
3190 PRINT #4,PREAMBLE$
3200 REPeat PRINTOUT
3210    IF EOF(#3) THEN EXIT PRINTOUT
3220    IF EMULATE=1 THEN B$=INCVT$(#3) : ELSE B$=INGET$(#3) : END IF 
3225    A$=CHARS$(141):A$=A$&A$&A$:IF A$ INSTR B$ THEN B$=CHR$(12) : INPUT #3,A$ : INPUT #3,A$ : INPUT #3,A$ : INPUT #3,A$ : INPUT #3,A$ : REMark Form Feed at end of page, and skip Line Feed
3230    PRINT #4,B$ : REMark ;CHR$(27);'J';CHR$(0);B$
3240    PRINT #4,LFPITCH$;
3250    END REPeat PRINTOUT
3260 PRINT #4,POSTAMBLE$
3270 CLOSE #4 : CLOSE #3
3280 END DEFine SPOOL
3290 DEFine FuNction PATTERN$(N,P)
3300 LOCal A$,MASK,I,ROW,L,C
3310 MASK=2^P : L=FONT2+2+9*(N-PEEK(FONT2)) : A$=''
3320 FOR I=1 TO P
3330 C=0
3340 FOR ROW=0 TO 7
3350 C=2*C : IF (PEEK(L+ROW)&&MASK)>0 THEN LET C=C+1
3360 NEXT ROW
3370 A$=A$&CHR$(C) : MASK=.5*MASK
3380 NEXT I
3390 RETurn A$
3400 END DEFine PATTERN$
3410 DEFine FuNction INCVT$(C)
3420 LOCal HIG$,TXT$,LOW$,A$,FLAG,N,ESC_S
3430 HIG$='' : TXT$='' : LOW$='' : FLAG=0 : ESC_S=0
3440 REPeat INLOOP
3450    IF EOF(#C) THEN EXIT INLOOP
3460    A$=INKEY$(#C) : N=CODE(A$) : IF N=10 THEN EXIT INLOOP
3470    A$=CHARS$(N)
3472    SELect ON FLAG
3475       =45: TXT$=TXT$&ESC$&'-'&A$ : FLAG=0
3480       =27: SELect ON N
3500          =83: FLAG=83 : ESC_S=1
3510          =84: FLAG=0
3515          =45: FLAG=45
3520          =REMAINDER : FLAG=0 : TXT$=TXT$&ESC$&A$
3530          END SELect 
3550       =83
3560          IF N=0 THEN FLAG=+999: ELSE FLAG=-999 : END IF 
3570       =REMAINDER 
3575          IF N=27 THEN FLAG=27
3580          IF FLAG=+999 THEN HIG$=HIG$&A$ : TXT$=TXT$&' ' : LOW$=LOW$&' '
3590          IF FLAG=-999 THEN HIG$=HIG$&' ' : TXT$=TXT$&' ' : LOW$=LOW$&A$
3600          IF FLAG=0 THEN HIG$=HIG$&' ' : TXT$=TXT$&A$ : LOW$=LOW$&' '
3620      END SELect 
3630    END REPeat INLOOP
3640 IF ESC_S=1 THEN A$=HIG$&ESC$&'J'&CHR$(12) & TXT$&ESC$&'J'&CHR$(12) & LOW$ : ELSE A$=TXT$ : END IF 
3650 RETurn A$
3660 END DEFine INCVT$
3700 DEFine FuNction INGET$(C)
3710 LOCal A$,B$
3720 B$=''
3730 REPeat GETLOOP
3740    IF EOF(#C) THEN EXIT GETLOOP
3750    A$=INKEY$(#C) : IF A$=CHR$(10) THEN EXIT GETLOOP
3760    B$=B$&A$
3770    END REPeat GETLOOP
3780 RETurn B$
3790 END DEFine INGET$
4000 REMark List of characters to replace
4010 DATA 128,132,999 : REMark 
4020 DATA 132,148,999 : REMark 
4030 DATA 135,129,999 : REMark 
4040 DATA 160,142,999 : REMark 
4050 DATA 164,153,999 : REMark 
4060 DATA 167,154,999 : REMark 
4070 DATA 156,225,999 : REMark 
4080 DATA 149,249,999 : REMark malpunkt
4090 DATA 150,251,999 : REMark wurzel
4100 DATA 146,244,27,65,8,999 : REMark Integral oberer Teil
4110 DATA 147,245,999 : REMark Integral unterer Teil
4120 DATA 139,236,999 : REMark unendlich
4130 DATA 152,253,999 : REMark Quadrat
4140 DATA 151,252,999 : REMark hoch n
4150 DATA 140,238,999 : REMark epsilon
4160 DATA 183,238,8,186,999: REMark nicht element
4170 DATA 142,240,999 : REMark identisch
4180 DATA 148,247,999 : REMark ungefhr
4190 DATA 141,239,999 : REMark schnittmenge
4200 DATA 143,241,999 : REMark +-
4210 DATA 144,242,999 : REMark >=
4220 DATA 145,243,999 : REMark >=
4230 DATA 177,227,999 : REMark 
4240 DATA 130,228,999 : REMark Summe
4250 DATA 185,175,999 : REMark 
4260 DATA 184,174,999 : REMark 
4270 DATA 186,248,999 : REMark 
4280 DATA 162,143,999 : REMark 
4290 DATA 153,171,999 : REMark 1/2
4300 DATA 154,172,999 : REMark 1/4
4310 DATA 172,224,999 : REMark 
4320 DATA 129,226,999 : REMark Gamma
4330 DATA 173,235,999 : REMark 
4340 DATA 174,233,999 : REMark 
4350 DATA 138,145,999 : REMark kappa
4360 DATA 176,230,999 : REMark 
4370 DATA 131,229,999 : REMark sigma
4380 DATA 136,231,999 : REMark tau
4390 DATA 178,232,999 : REMark 
4400 DATA 137,234,999 : REMark Omega
4420 DATA 159,96,999 : REMark 
4490 DATA 169,159,999 : REMark f geschwungen
4500 DATA 96,156,999 : REMark `
4510 DATA 124,179,999 : REMark |
4520 DATA 133,27,52,999 : REMark Italic on
4530 DATA 161,27,53,999 : REMark Italic off
4540 DATA 165,205,27,65,8,999 : REMark Bruchstrich
4550 DATA 157,27,84,999 : REMark Subscript/Superscript Termination
4560 DATA 158,27,83,0,999 : REMark Superscript
4570 DATA 134,27,83,1,999 : REMark Subscript
4580 DATA 141,32,27,65,8,999 : REMark Temporary Linefeed set
4600 DATA -1 : REMark end of character replace table
5000 REMark Characters which have to be printet in dot - image graphic
5010 DATA 180,179,155,181,171,170,163,168,188,189,190,191,166,187,999
10000 DEFine PROCedure SVE
10010 DELETE FLP1_BOOT : SAVE FLP1_BOOT
10020 END DEFine SVE
