; This program is used to replace the sequence
;       MOVEQ   #$25,D0
;       TRAP    #3
; in the programm QUILL by a call to a routine, which sets
; a userdefined characterset instead of the normal one.
; this programm must preceede the normal code for Quill
; The patch of the character founts must be done by the BASIC programm
; PATCH_QUILL_BAS
;
          SECTION   QUILLFONT
        BRA     BEGIN
        DC.L    $4AFB
        DC.W    5
        DC.B    'QUILL '
        DC.L    'RAKO'          ; identifier for patch programm
FONT1:  DS.L    290
FONT2:  DS.L    290             ; maximum number of font characters
SUPER1: DS.L    290             ; superscript first font
SUPER2: DS.L    290             ; superscript secont font
SUB1:   DS.L    290             ; subscript first font
SUB2:   DS.L    290             ; subscript second font
STORE:  DS.L    8
PROC_DEF:
        DC.W    1
        DC.W    FN_QUILL-*
        DC.B    5,'QUILL'
        DC.W    0
        DC.W    0
        DC.W    0
BEGIN:  MOVEM.L A0-A3/A6/D0-D3,-(A7)
        MOVEQ   #0,D0           ; MT.INF to get current job ID
        TRAP    #1
        LEA     STORE,A0
        MOVE.L  D1,(A0)         ; store job ID
        BSR     SUS_BAS
        MOVE.L  $28068,A6 ; Make some effort to get BASICs A6
        MOVE.L  (A6),A6
        MOVE.L  88(A6),A6 ; Stored value of A6
        LEA     PROC_DEF,A1     ; Initialize basic function to multitask
        MOVE.W  $110,A2         ; Quill
        JSR     (A2)
        LEA     SEQ2,A0
        LEA     SETFNT,A1
        MOVE.L  A1,2(A0)
        LEA     SEQ1,A0         ;The sequence we are searching for.
        MOVE.L  (A0),D0
        LEA     STA_QUIL,A0     ;begin of programm
        BSR.S   SEARCH          ;Ignore first ocurence
        ADD.L   #2,A0
        BSR.S   SEARCH
        SUBA.L  #4,A0           ;starts with MOVEA.L $10(A0),A0
        LEA     SEQ2,A1         ;new program part
        MOVE.W  (A1)+,(A0)+     ;JSR
        MOVE.L  (A1)+,(A0)+     ;address to jump. TRAP #3 on return
        MOVEM.L (A7)+,A0-A3/A6/D0-D3
        BRA     STA_QUIL
SEARCH: CMP.L   (A0),D0
        BEQ.S   FOUND
        ADDQ.L  #2,A0
        BRA.S   SEARCH
FOUND:  RTS
SEQ1:   MOVEQ   #$25,D0
        TRAP    #3
SEQ2:   JSR     $F0000
SETFNT: CMPA.L  #$28000,A2      ; Second fount other than ROM ?
        BCC.S   TSTF1
        MOVE.L  A2,D0
        LEA     FONT2,A2
        TST.L   (A2)
        BNE.S   TSTF1
        MOVE.L  D0,A2
TSTF1:
        CMPA.L  #$28000,A1      ; First fount other than ROM ?
        BCC.S   TSTSUB
        MOVE.L  A1,D0
        LEA     FONT1,A1
        TST.L   (A1)
        BNE.S   DOTRAP
        MOVE.L  D0,A1
        BRA.S   DOTRAP
TSTSUB:
        MOVE.B  (A1),D0         ; lowest valid character
        CMP.B   #$1F,D0
        BCS.S   DOTRAP          ; if characters below $1F are valid
        MOVE.B  1(A1),D0        ; number of valid characters
        CMP.B   #$30,D0         ; this is the minimum i think
        BCS.S   DOTRAP
        MOVE.B  (A1),D0
        CMP.B   3(A1),D0 ; Superscript begins 3 byte before subscript
        BEQ.S   SUPER
        MOVE.L  A1,D0
        LEA     SUB1,A1
        TST.L   (A1)
        BNE.S   CONT_1
        MOVE.L  D0,A1
CONT_1: MOVE.L  A2,D0
        LEA     SUB2,A2
        TST.L   (A2)
        BNE.S   DOTRAP
        MOVE.L  D0,A2
        BRA.S   DOTRAP
SUPER:
        MOVE.L  A1,D0
        LEA     SUPER1,A1
        TST.L   (A1)
        BNE.S   CONT_2
        MOVE.L  D0,A1
CONT_2: MOVE.L  A2,D0
        LEA     SUPER2,A2
        TST.L   (A2)
        BNE.S   DOTRAP
        MOVE.L  D0,A2
DOTRAP: MOVEA.L $10(A0),A0
        MOVEQ   #$25,D0
        RTS
FN_QUILL:
        LEA     STORE,A1
        MOVE.L  (A1),D1         ; get Job ID of Quill
        MOVEQ   #9,D0 ; Release Job
        TRAP    #1
SUS_BAS:
        MOVEQ   #0,D1           ; Basics Job ID
        MOVEQ   #8,D0           ; MT.SUSJB
        MOVEQ   #-1,D3          ; infinite time
        SUBA.L  A1,A1           ; No flag byte
        TRAP    #1              ; Suspend basic
        RTS
STA_QUIL:
        NOP
        END
