9990 REMark --- User defined character editor    1984 Tony Tebby   QJUMP
10000 init_udc
10010 REPeat char_edit
10020   IF end_udc: EXIT char_edit
10030   AT 0,0:PAPER 2
10040   PRINT #2,'Use the keys  to move the cursor'
10050   PRINT #2,'SPACE/other to clear/set each pixel'
10060   PRINT #2,'ENTER for next char      ESC to end'
10070   FOR char=first_char TO max_char
10080     init_char
10090     REPeat char_def
10100       CSIZE 2,0: AT ybase+row,xbase+column
10110       CURSEN: in=CODE(INKEY$(#1,-1)): CURDIS
10120       SELect ON in
10130       =left:  IF column>0: column=column-1
10140       =right: IF column<4: column=column+1
10150       =up:    IF row>0: row=row-1
10160       =down:  IF row<8: row=row+1
10170       =enter: EXIT char_def
10180       =esc  : EXIT char
10190       =space: bit_clear
10200       =REMAINDER : bit_set
10210       END SELect 
10220     END REPeat char_def
10230   END FOR char
10240   CLS #2
10250 END REPeat char_edit
10260 IF FOP_OVER (#3,filnam$): perror 'File error'
10270 FOR i=fbase TO fbase+fsize-1: BPUT #3,PEEK(i)
10280 CLOSE #3
10285 PRINT #0;fsize!'bytes in fount'
10290 RECHP fbase
10300 REMark ----------------------------------------
10310 :
10320 DEFine PROCedure bit_clear
10330 addr=foffset+char*9+row
10340 POKE addr,PEEK(addr)&&~~2^(6-column)
10350 bit_write 0
10360 END DEFine bit_clear
10370 REMark ------------------------------------------
10380 :
10390 DEFine PROCedure bit_set
10400 addr=foffset+char*9+row
10410 POKE addr,PEEK(addr)||2^(6-column)
10420 bit_write 4
10430 END DEFine bit_set
10440 REMark ----------------------------------------
10450 :
10460 DEFine PROCedure bit_write (bit_colr)
10470 PAPER bit_colr: PRINT ' '
10480 column=column+1
10490 IF column>4
10500   column=0: row=(row+1) MOD 9
10510 END IF 
10520 AT ybase+2,xbase+7: CHAR_USE fbase,0: PAPER 0
10530 CSIZE 1,0: BPUT char
10540 CSIZE 3,0: BPUT char
10550 CSIZE 3,1: BPUT char
10560 CSIZE 2,0: PAPER 2
10570 AT 1+(char-min_char) DIV 16,4+(char-min_char) MOD 16: BPUT char
10580 CHAR_USE 0,0
10590 END DEFine bit_write
10600 REMark -------------------------------------
10610 :
10620 DEFine PROCedure init_udc
10630 enter=10: esc=27: space=32
10640 left=192: right=200: up=208: down=216
10650 ybase=3: xbase=21
10660 min_char=128: max_char=140
10670 :
10680 REMark set up the windows
10690 WINDOW #2,448, 30,32,16
10700 WINDOW #1,448,170,32,46: PAPER 2
10710 WINDOW #0,448,40,32,216
10720 MODE 4: CSIZE #0,2,0: CSIZE #2,2,0
10730 :
10740 REMark set up character file
10750 new_file=find_file
10760 IF new_file
10770   INPUT #0,'Lowest character value  >';min_char
10780   INPUT #0,'Highest character value >';max_char
10790   CLS #0
10800   IF max_char<min_char OR max_char>255: perror 'Out of range'
10810   fsize=11+9*(max_char-min_char)
10820   fbase=ALCHP(fsize)
10830   IF NOT fbase: perror 'Out of memory'
10840   POKE fbase,min_char
10850   POKE fbase+1,max_char-min_char
10860 ELSE 
10870   fsize=FLEN(#3)
10880   fbase=ALCHP(fsize)
10890   IF NOT fbase: perror 'Out of memory'
10900   FOR i=fbase TO fbase+fsize-1: BGET #3,b%: POKE i,b%
10910   CLOSE #3
10920   min_char=PEEK(fbase)
10930   max_char=PEEK(fbase+1)+min_char
10950 END IF 
10960 foffset=fbase+2-min_char*9
10970 print_all
10980 END DEFine init
10990 REMark ------------------------------------------
11000 :
11010 DEFine FuNction find_file
11020 INPUT #0,'Fount file name >';filnam$
11030 IF FOPEN (#3,filnam$)=0: RETurn 0 : REMark file exists
11040 IF FOP_NEW (#3,filnam$): perror 'File error'
11050 CLOSE #3: REMark Now file exists
11060 RETurn 1
11070 END DEFine findfile
11080 REMark ------------------------------------------
11090 :
11100 DEFine FuNction end_udc
11110 IF new_file
11120   first_char=min_char
11130   new_file=0
11140   RETurn 0
11150 ELSE 
11160   REPeat get_first
11170     INPUT #0,\\'Edit char value (ENTER to quit) >';a$
11180     CLS #0
11190     IF a$="": RETurn 1
11200     first_char=a$
11210     IF first_char>=min_char: RETurn 0
11220   END REPeat get_first
11230 END IF 
11240 END DEFine end_edit
11250 REMark ------------------------------------------
11260 :
11270 DEFine PROCedure init_char
11280 CSIZE 2,0
11290 PAPER 2: AT ybase-1,xbase: PRINT FDEC$(char,5,0)
11300 FOR row=0 TO 8
11310   bit%=2^6
11320   byte%=PEEK(foffset+char*9+row)
11330   AT ybase+row,xbase
11340   FOR column=0 TO 4
11350     bit_colr=0
11360     IF byte%&&bit% : bit_colr=4
11370     PAPER bit_colr
11380     PRINT ' ';
11390     bit%=bit% DIV 2
11400   END FOR column
11410 END FOR row
11420 AT ybase+8,xbase+4: bit_write bit_colr
11430 END DEFine init_char
11440 REMark -------------------------------------------
11450 :
11460 DEFine PROCedure print_all
11470 CSIZE 2,0: CLS
11480 FOR char=min_char TO max_char
11490   IF (char-min_char) MOD 16 = 0
11500     CHAR_USE 0,0: PRINT \FDEC$(char,3,0);' ';
11510     CHAR_USE fbase,0
11520   END IF 
11530   BPUT char
11540 END FOR char
11550 CHAR_USE 0,0
11560 END DEFine print_all
11570 REMark ------------------------------------------
11580 :
11590 DEFine PROCedure perror (text)
11600 BEEP 2000,50
11610 PRINT #0,\text
11620 STOP
11630 END DEFine perror
